#include "iplookup.h"

col_short_t *compress_col_index_type (col_index_t *col_index) {
  col_short_t *col_short;
  ip_addr_t i, exp_col = exp (K_SIZE);
  printf ("Compressing colun index...");
  col_short = (col_short_t *) malloc (exp_col * sizeof (col_short_t));
  if (col_short == NULL) {
    printf ("fail\nMalloc failure... error safely ignored");
    return NULL;
  }
  for (i = 0; i < exp_col; i ++)
    col_short[i] = col_index[i];
  printf ("done\n");
  return col_short;
}

ip_addr_t compute_bucket_size (col_index_t *col_index) {
  ip_addr_t i, bucket, exp_col = exp (K_SIZE);
  bucket = 1;  /* At least one bucket exist */
  for (i = 1; i < exp_col; i ++)
    if (col_index[i - 1] != col_index[i]) bucket ++;
  bucket = exp (K_SIZE) / bucket; 
  i = 0;
  while (bucket != 0) {
    bucket >>= 1;
    i ++;
  }
  bucket = 1 << i;
  return bucket;
}

ip_addr_t tot_bucket_fault (col_index_t *col_index, ip_addr_t bucket) {
  ip_addr_t faults = 0;
  ip_addr_t i, j, offset, exp_col = exp (K_SIZE);
  for (i = 0; i < exp_col / bucket; i ++) {
    offset = i * bucket;
    for (j = 1; j < bucket; j ++) {
      if (col_index[offset + j] != col_index[offset + j - 1]) {
	faults ++;
	j = bucket;
      }
    }
  }
  return faults;
}

bucket_t *create_bucket_col_index (col_index_t *col_index) {
  bucket_t *col_bucket;
  ip_t fault;
  ip_addr_t i, j, k=0, offset, buck = 0;
  ip_addr_t size = compute_bucket_size (col_index);
  ip_addr_t fail = tot_bucket_fault (col_index, size);
  ip_addr_t tot_bucket = (exp (K_SIZE) / size);
  printf ("Creating bucket colun index...");
  col_bucket =  (bucket_t *) malloc ((tot_bucket + (size * fail)) * 
				     sizeof (bucket_t));
  if (col_bucket == NULL) return NULL;
  for (i = 0; i < tot_bucket; i ++) {
    offset = i * size;
    fault = 0;
    for (j = 1; j < size; j ++) {
      if (col_index[offset + j] != col_index[offset + j - 1]) {
        fault = 1;
        j = size;
      }
    }
    if (fault == 0)
      col_bucket[i] = col_index[offset];
    else {
      col_bucket[i] = -buck - 1;
      for (k = 0; k < size; k ++) 
	col_bucket[((tot_bucket + (buck * size))) + k] = col_index[offset + k];
      buck ++;
    }
  }
  printf ("done\nTotal buchet %u size %u fail %u\n",tot_bucket,size,fail);
  printf ("Total bytes %u\n",(tot_bucket + (size * fail)) * sizeof (bucket_t));
  return col_bucket;
}
