#include "iplookup.h"

long int Mark_Time (void) {
  static struct timeval TimeStart;
  struct timeval TimeEnd;
  static char set = 0;
  if (set == 0) {
    set ++;
    gettimeofday (&TimeStart, NULL);
    return 0;
  }
  else {
    set = 0;
    gettimeofday (&TimeEnd, NULL);
    return ((TimeEnd.tv_sec - TimeStart.tv_sec) * 1000000) +
      (TimeEnd.tv_usec - TimeStart.tv_usec);
  }
}

char eval_params (int argc, char *argv[], ip_addr_t *ntimes) {
  short int i;  
  char flag = 0;
  if ((argc < 2) || (argc > 5)) echo_use ();
  switch (argc) {
  case 2:
    if (!strcmp (argv[1] ,"-H") || !strcmp (argv[1] ,"-h")) {
      help ();
      exit (1);
    }
    else echo_use ();
    break;
  case 3:
    for (i = 0; i < strlen (argv[1]); i ++)
      if (argv[1][i] < '0' || argv[1][i] > '9') {
	flag = 1;
	break;
      }
    if (flag == 0)
      *ntimes = atol (argv[1]);
    flag = 0;
    break;
  case 4:
    if (argv[1][0] == '-') {
      for (i = 0; i < strlen (argv[2]); i ++)
	if (argv[2][i] < '0' || argv[2][i] > '9') {
	  flag = 1;
	  break;
	}
      if (flag == 0) {
	*ntimes = atol (argv[2]);
	if (*ntimes != 0) echo_use ();
      }
      flag = 0;
      /*  ignore - at start of string  */
      for (i = 1; i < strlen (argv[1]); i ++) {
        if (toupper (argv[1][i]) == 'L') flag ++;
        if (toupper (argv[1][i]) == 'H') {
	  help ();
	  exit (1);
	}
        if (toupper (argv[1][i]) == 'S') flag += 8;
        if (toupper (argv[1][i]) == 'Q') flag += 16;
        if (toupper (argv[1][i]) == 'C') flag += 32;
        if (toupper (argv[1][i]) == 'G') flag += 64;
      }
    }
    else {
      for (i = 0; i < strlen (argv[1]); i ++)
	if (argv[1][i] < '0' || argv[1][i] > '9') {
	  flag = 1;
	  break;
	}
      if (flag == 0)
	*ntimes = atol (argv[1]);
      else 
	echo_use ();
      flag = 0;
      if (*ntimes == 0) {
	if (argv[2][0] == '-') {
	  /*  ignore - at start of string  */
	  for (i = 1; i < strlen (argv[2]); i ++) {
	    if (toupper (argv[2][i]) == 'L') flag ++;
	    if (toupper (argv[2][i]) == 'H') {
	      help ();
	      exit (1);
	    }
	    if (toupper (argv[2][i]) == 'S') flag += 8;
	    if (toupper (argv[2][i]) == 'Q') flag += 16;
	    if (toupper (argv[2][i]) == 'C') flag += 32;
	    if (toupper (argv[2][i]) == 'G') flag += 64;
	  }
	}
	else echo_use ();
      }
    }
    break;
  case 5:
    if (argv[1][0] == '-') {
      *ntimes = atol (argv[2]);
      /*  ignore - at start of string  */
      for (i = 1; i < strlen (argv[1]); i ++) {
        if (toupper (argv[1][i]) == 'L') flag ++;
        if (toupper (argv[1][i]) == 'H') {
	  help ();
	  exit (1);
	}
        if (toupper (argv[1][i]) == 'S') flag += 8;
        if (toupper (argv[1][i]) == 'Q') flag += 16;
        if (toupper (argv[1][i]) == 'C') flag += 32;
        if (toupper (argv[1][i]) == 'G') flag += 64;
      }
    }
    else {
      *ntimes = atol (argv[1]);
      /*  ignore - at start of string  */
      for (i = 1; i < strlen (argv[2]); i ++) {
        if (toupper (argv[2][i]) == 'L') flag ++;
        if (toupper (argv[2][i]) == 'H') {
	  help ();
	  exit (1);
	}
        if (toupper (argv[2][i]) == 'S') flag += 8;
        if (toupper (argv[2][i]) == 'Q') flag += 16;
        if (toupper (argv[2][i]) == 'C') flag += 32;
        if (toupper (argv[2][i]) == 'G') flag += 64;
      }
    }
    break;
  }
  return flag;
}

void echo_use (void) {
  printf ("Use: cdglookup [iteration] [-LHaSQCG] <table file> [addr. file]\n");
  printf ("Try 'cdglookup -H' for more information.\n");
  exit (-2);
}

void help (void) {
  printf ("cdglookup [iteration] [-LHaSQCG] <table file> [addr. file]\n\n");
  printf ("iteration is the number of times that, lookups of each address\n");
  printf ("in address file, will be performed\n");
  printf ("if iteration is 0 no lookups will be performed and address file\n");
  printf ("parameter is unspecified\n");
  printf ("Options:\n");
  printf ("-H to obtain this help\n");
  printf ("-L to append to cdg.log basic information about table\n");
  printf ("-S to use splitted routing table\n");
  printf ("-Q to use quadruple front end instead of trie\n");
  printf ("-C to force use colun index instead of best solution\n");
  printf ("-G to force use CDG lookup\n");
  printf ("Returned value\n");
  printf (" 0 if success\n");
  printf ("-1 if error\n");
  printf ("-2 if parameter error\n");
  printf (" 1 If help was requested\n");
}

void write_log_file (ip_addr_t *tot_rows, col_index_t *row_len, ip_addr_t b_size, ip_addr_t b_tmp, char flag, char comp_col, long tempo) {
  FILE *log;
  ip_addr_t i;
  if ((log = fopen ("cdg.log","a")) == NULL) {
    printf ("Unable to create log file\n");
    return;
  }
  fprintf(log,"Table size (rows x cols) %u x %u\n",tot_rows[0],row_len[0]);
  /*  Compute the table size  */
  if (comp_col == 2) {
    fprintf (log, "Bucket col index: %u buckets, %u bucket size, %u faults\n",
	     (exp (K_SIZE) / b_size), b_size, b_tmp);
    /*  compute bucket col index size  */
    b_tmp = ((exp (K_SIZE) / b_size) + (b_size * b_tmp)) * sizeof (bucket_t);
    i = ((tot_rows[0] * row_len[0]) * sizeof (cell_t)) + 
      (sizeof(cell_t *) * exp(32-K_SIZE)) + b_tmp;
  }
  else { /*  Compute case comp_col = 0 or 1  */
    if (comp_col == 0)
      fprintf (log,"Normal col_index used\n");
    else
      fprintf (log,"Short col_index used\n");
    i = ((tot_rows[0] * row_len[0]) * sizeof (cell_t)) + 
      (sizeof (cell_t *) * exp(32 - K_SIZE))
      + ((sizeof (col_index_t) * exp (K_SIZE)) >> comp_col);
  }
  /*  if -S must to add (sizeof (cell_t *) * exp(32 - K_SIZE)) bytes  */
  if (flag & 8) i += (sizeof (cell_t *) * exp(32 - K_SIZE));
  fprintf (log,"Bytes = %u   Kb = %.2f   Mb = %.2f\n",
	   i, (double) i / 1024, (double) i / 1048576); 
  fprintf (log,"Elapsed time %ld\n", tempo);
  fclose (log);
}

void write_log_lookup (char comp_col, long *look_time) {
  FILE *log;
  if ((log = fopen ("cdg.log","a")) == NULL) {
    printf ("Unable to create log file\n");
    return;
  }
  switch (comp_col) {
  case 0:
    fprintf (log, "Normal lookup procedure\n"); 
    break;
  case 1:
    fprintf (log, "Short type lookup procedure\n");
    break;
  case 2:
    fprintf (log, "bucket lookup procedure\n");
    break;
  }
  fprintf (log, "-- Lookup time --\n");
  fprintf (log, "Entire lookup procedure %ld\n",look_time[1]);
  fprintf (log, "No lookup operations %ld\n",look_time[0]);
  fprintf (log, "Real lookup time %ld\n",look_time[1] - look_time[0]);
  fclose (log);
}

void write_results (addr_table_t **array, ip_addr_t len, char **next_hop, char flag) {
  ip_addr_t i;
  FILE *pf;
  /*  Open log file  */
  if ((pf = fopen ("cdglookup.log","w")) == NULL) {
    printf ("Unable to write log file\n");
    return;
  }
  /*  Store lookups results in log file  */
  for (i = 0; i < len; i ++) {
    /*  Look if operation is lookup  */
    if (array[i]->op == LOOKUP) {
      /*  for 17 bit split table  */
      if (flag) array[i]->first_pair >>= 1;
      /*  write the address looked up  */
      fprintf (pf,"%u.%u.%u.%u -> ",
	       array[i]->first_pair >> 8,
	       array[i]->first_pair % 256,
	       array[i]->last_pair >> 8,
	       array[i]->last_pair % 256); 
      /*  array[i]->next_hop contain the index of next_hop array, 
	  by costruction in ins_in_next_hop_array function         */
      fprintf (pf, "%s\n",next_hop[array[i]->next_hop]);
    }
  }
  /*  Close */
  fclose (pf);
}

long no_lookup_time (addr_table_t **array, ip_addr_t len, ip_addr_t ntimes) {
  register ip_addr_t i,j;
  Mark_Time ();
  /*  repeat the same operation n times  */
  for (i = 0; i < ntimes; i ++) {
    /*  Each loop is a lookup  */
    for (j = 0; j < len; j ++) {
      /*  empty assigment  */
      switch (array[j]->op) {
      case LOOKUP:
	array[j]->next_hop = 0;
	break;
      case INSERT:
	break;
      case DELETE:
	break;
      }
    }
  }
  return Mark_Time ();
}
