#include <stdio.h>
#include "iplookup.h"

int last = -1;
ip_t last_n = 0;
void btree_visita (trie_t *root, ip_addr_t ip, ip_t netmask, 
		   FILE *out[2], char **nh);

int main (int argc, char *argv[]) {
  FILE *out[2];
  char buff[MAX_RIGA_READ];
  struct net_table *in_table;
  trie_t *root;
  char *next_hops[MAX_NEXT_HOPS];
  ip_addr_t tot_route;
  if (argc != 2) {
    printf ("Use: verify <table file>\n");
    return -2;
  }
  in_table = load_table (argv[1], next_hops, &tot_route, 0);
  if (!in_table) {
    printf ("Program aborted\n");
    return -1;
  }
  root = create_trie (in_table, &tot_route);
  if (!root) {
    printf ("Unable to create trie\n");
    return -1;
  }
  
  strcpy (buff, argv[1]);
  strcat (buff,".reply");
  if ((out[0] = fopen (buff,"w")) == NULL) {
    printf ("Unable to open output file\n");
    return -1;
  }
  strcpy (buff, argv[1]);
  strcat (buff,".query");
  if ((out[1] = fopen (buff,"w")) == NULL) {
    printf ("Unable to open output file\n");
    return -1;
  }
  /*  make lookups  */
  btree_visita (root, 0, 0, out, next_hops);
  /*  insert last element  */
  if (last != 32) {
      fprintf (out[0],"255.255.255.255 -> %s\n", next_hops[last]);
      fprintf (out[1],"255.255.255.255\n");
  }
  /*  Dispose resources  */
  unload_next_hops (next_hops);
  fclose (out[0]);
  fclose (out[1]);
  return 0;
}

void btree_visita (trie_t *root, ip_addr_t ip, ip_t netmask, 
		   FILE *out[2], char **nh) {
  ip_addr_t right_side;
  if (root->child[0] == NULL && root->child[1] == NULL) {
    if (root->next_hop != last) {
      if (ip != 0) {
	right_side = ip - 1;
	if (last_n != 32) {
	  fprintf (out[0],"%u.%u.%u.%u -> %s\n",right_side >> 24, 
		   (right_side >> 16) % 256, (right_side >> 8) % 256, 
		   right_side % 256, nh[last]);
	  fprintf (out[1],"%u.%u.%u.%u\n",right_side >> 24, 
		   (right_side >> 16) % 256, (right_side >> 8) % 256, 
		   right_side % 256);
	}
      }
      fprintf (out[0],"%u.%u.%u.%u -> %s\n",ip >> 24, (ip >> 16) % 256,
	       (ip >> 8) % 256, ip % 256, nh[root->next_hop]);
      fprintf (out[1],"%u.%u.%u.%u\n",ip >> 24, (ip >> 16) % 256,
	       (ip >> 8) % 256, ip % 256);
      last = root->next_hop;
      last_n = netmask;
    }
    return;
  }
  if (root->child[0] != NULL) 
    btree_visita (root->child[0], ip, netmask + 1, out, nh);
  if (root->child[1] != NULL) 
    btree_visita (root->child[1], ip | (1 << (31 - netmask)),
		  netmask+1,out,nh);
}

ip_addr_t ip_1 (ip_addr_t address, ip_t netmask) {
  if (netmask == 32) return address;
  return address | ((1 << (32 - netmask)) - 1);
}
