#include "iplookup.h"

cell_t **rebuild_table (rle_t **RLE_seq, char flag, col_index_t *col_index, ip_addr_t tot_route, ip_addr_t *tot_rows, col_index_t *row_len) {
  cluster_t **cluster = NULL;
  ip_addr_t *sort = NULL;
  ip_addr_t *metric;
  ip_addr_t exp_col = exp (K_SIZE);
  cell_t **row_index;
  ip_addr_t i;
  sort = (ip_addr_t *) malloc (exp (K_SIZE) * sizeof (ip_addr_t));
  if (sort == NULL) {
    printf ("Malloc failure allocating sort vector... can't go on\n");
    return NULL;
  }
  cluster = create_cluster (RLE_seq, &tot_route, sort, &tot_rows[0]);  
  if (cluster == NULL) return NULL;
  i = exp_col >> 1;
  create_colun_index (col_index, cluster, tot_route, exp (32 - K_SIZE)); 
  metric = create_metrics (col_index);
  if (metric == NULL) return NULL;
  /*  Create table */
  row_len[0] = col_index[exp (32 - K_SIZE) - 1] + 1;  /*  by costruction  */
  row_index = create_ip_table (cluster, tot_route, sort, metric, 
			       row_len[0], tot_rows[0]);
  if (row_index == NULL) return NULL;
  printf ("table size (rows x cols) %u x %u\n",tot_rows[0], row_len[0]);
  return row_index;
}


void *build_col_index (col_index_t *col_index, char flag, col_index_t *row_len, ip_addr_t *b_size, ip_addr_t *b_tmp, char *comp_col) {
  bucket_t *col_bucket = NULL;
  col_short_t *col_short = NULL;
  ip_addr_t i, tmp;
  /*  Verify if colunn index is compressable in short type  */
  if (row_len[0] < MAX_SHORT_COL) *comp_col = 1;
  /* Force use normal col_index or comressed col_index NO bucket index  */
  if (flag & 32) {
  /*  Compress colunn index in shorter type if possible and necessary */
    if (*comp_col == 1) {
      col_short = compress_col_index_type (col_index);
      if (col_short == NULL) 
	*comp_col = 0;  /* col_index is not compressed */
      else
	return (void *) col_short;
    }
    return (void *) col_index;
  }
  /*  compute the short possible colun index type  */
  *b_size = compute_bucket_size (col_index);
  *b_tmp = tot_bucket_fault (col_index, *b_size);
  /*  compute size of col index or, if possible, short index  */
  i = (exp (K_SIZE) * sizeof (col_index_t)) >> *comp_col;
  /*  compute bucket index size  */
  tmp = ((exp (K_SIZE) / *b_size) + (*b_size * *b_tmp)) * sizeof (bucket_t);
  /*  choose the shortest  */
  if (i > tmp) {
    /*  create bucket colun index  */
    col_bucket = create_bucket_col_index (col_index);
    if (col_bucket != NULL) {
      *comp_col = 2;
      return (void *) col_bucket;
    }
  }
  /*  Compress colunn index in shorter type if possible and necessary */
  if (*comp_col == 1) {
    col_short = compress_col_index_type (col_index);
    if (col_short == NULL)
      *comp_col = 0;  /* col_index is not compressed */
    else
      return (void *) col_short;
  }
  return (void *) col_index;
}
