#include "iplookup.h"

ip_addr_t query_K_partition (K_part_t *part, ip_addr_t query, basic_t *points){
  ip_addr_t i = Exp (31);
  ip_addr_t bf = 2 * (i / K_PART);
  ip_addr_t ch1 = query / bf;
  basic_t *block;
  /*  Correction for last bucket, because may be bigger than other  */
  if (ch1 >= K_PART) ch1 = K_PART - 1;
  if (part[ch1].len == 1) {
    if (points[part[ch1].endpoints[0]].endpoint > query)
      return part[ch1].endpoints[0] - 1;
    else
      return part[ch1].endpoints[0];
  }
  else {
    if (points[part[ch1].endpoints[0]].endpoint > query)
      return part[ch1].endpoints[0] - 1;
    block = &points[part[ch1].endpoints[0]];
    return binary_search (block, part[ch1].len, query) + 
      part[ch1].endpoints[0];
  }
  return ~0;  /*  Never happen  */
}

void dump_K_partition (K_part_t *part) {
  ip_addr_t i = Exp (31);
  ip_addr_t bf = 2 * (i / K_PART);
  for (i = 0; i < K_PART; i ++) {
    printf ("%u) [%u %u] -> %u | base %u\n",i,part[i].endpoints[0],
            part[i].endpoints[1], part[i].len, (i * bf));
  }
}

K_part_t *create_K_partition (basic_t *points, ip_addr_t len, ip_addr_t *mem) {
  K_part_t *part;
  ip_addr_t i = Exp (31);
  ip_addr_t j, bf = 2 * (i / K_PART);
  /*  Create root  */
  part = (K_part_t *) malloc (K_PART * sizeof (K_part_t));
  if (part == NULL) return NULL;
  *mem = *mem + (K_PART * sizeof (K_part_t));
  for (i = 0; i < K_PART; i ++) part[i].len = 0;
  /*  set endpoints  */
  j = 0;
  for (i = 0; i < len && j < K_PART - 1; i ++) {
    if (points[i].endpoint < ((j + 1) * bf)) {
      if (part[j].len == 0) {
	part[j].endpoints[0] = i;
	part[j].endpoints[1] = i;
      }
      else {
	part[j].endpoints[1] = i;
      }
      part[j].len ++;
    }
    else {
      j ++;
      i --;
    }
  }
  /*  In case last endpoint inserted is with len = 0  */
  if (K_PART > 1)
    if (part[K_PART - 2].endpoints[0] > part[K_PART - 2].endpoints[1])
      part[K_PART - 2].endpoints[1] = part[K_PART - 2].endpoints[0];

  /*  insert last rules if there are  */
  if (j == K_PART - 1) {
    part[j].endpoints[0] = i;
    part[j].endpoints[1] = len - 1;
    part[j].len = len - i;
  }
  /*  Set endpoints value for empty intervals  */
  for (i = 1; i < K_PART; i ++)
    if (part[i].len == 0) {
      part[i].len = 1;
      part[i].endpoints[0] = part[i - 1].endpoints[1];
      part[i].endpoints[1] = part[i - 1].endpoints[1];
    }
  return part;
}

