#include "iplookup.h"

ip_addr_t query_N_partition (N_part_t *root, ip_addr_t query, basic_t *points, 
			     ip_addr_t len) {
  ip_addr_t bf = 2 * (Exp (31) / len);
  ip_addr_t ch1 = query / bf;
  basic_t *block;
  /*  Correction for last bucket, because may be bigger than other  */
  if (ch1 >= len) ch1 = len - 1;
  if (root->kids[ch1].len == 1) {
    if (points[root->kids[ch1].endpoints[0]].endpoint > query)
      return root->kids[ch1].endpoints[0] - 1;
    else
      return root->kids[ch1].endpoints[0];
  }
  else {
    if (points[root->kids[ch1].endpoints[0]].endpoint > query)
      return root->kids[ch1].endpoints[0] - 1;
    block = &points[root->kids[ch1].endpoints[0]];
    return binary_search (block, root->kids[ch1].len, query) + 
      root->kids[ch1].endpoints[0];
  }
  return ~0;  /*  Never happen  */
}

void dump_N_partition (N_part_t *root) {
  ip_addr_t i;
  ip_addr_t bf = 2 * (Exp (31) / root->len);
  for (i = 0; i < root->len; i ++) {
    printf ("%u) [%u %u] -> %u | base %u\n",i,root->kids[i].endpoints[0],
            root->kids[i].endpoints[1], root->kids[i].len, (i * bf));
  }
}

N_part_t *create_N_partition (basic_t *points, ip_addr_t len, ip_addr_t *mem) {
  N_part_t *root;
  ip_addr_t i, j, bf = 2 * (Exp (31) / len);
  /*  Create root  */
  root = (N_part_t *) malloc (sizeof (N_part_t));
  if (root == NULL) return NULL;
  *mem = *mem + sizeof (N_part_t);
  root->len = len;
  /*  FIrst level  */
  root->kids = (N_elems_t *) malloc (len * sizeof (N_elems_t));
  if (root->kids == NULL) return NULL;
  *mem = *mem + (len * sizeof (N_elems_t));
  for (i = 0; i < len; i ++) root->kids[i].len = 0;
  /*  set endpoints  */
  j = 0;
  for (i = 0; i < len && j < len - 1; i ++) {
    if (points[i].endpoint < ((j + 1) * bf)) {
      if (root->kids[j].len == 0) {
	root->kids[j].endpoints[0] = i;
	root->kids[j].endpoints[1] = i;
      }
      else {
	root->kids[j].endpoints[1] = i;
      }
      root->kids[j].len ++;
    }
    else {
      j ++;
      i --;
    }
  }
  /*  In case last endpoint inserted is with len = 0  */
  if (len > 1)
    if (root->kids[len-2].endpoints[0] > root->kids[len-2].endpoints[1])
      root->kids[len-2].endpoints[1] = root->kids[len-2].endpoints[0];

  /*  insert last rules if there are  */
  if (j == len - 1) {
    root->kids[j].endpoints[0] = i;
    root->kids[j].endpoints[1] = len - 1;
    root->kids[j].len = len - i;
  }
  /*  Set endpoints value for empty intervals  */
  for (i = 1; i < len; i ++)
    if (root->kids[i].len == 0) {
      root->kids[i].len = 1;
      root->kids[i].endpoints[0] = root->kids[i - 1].endpoints[1];
      root->kids[i].endpoints[1] = root->kids[i - 1].endpoints[1];
    }
  return root;
}

