#include "iplookup.h"

cell_t **rebuild_table (rle_t **RLE_seq, char flag, ip_addr_t tot_route, ip_addr_t *tot_rows, col_index_t *row_len) {
  cluster_t **cluster = NULL;
  ip_addr_t *sort = NULL;
  ip_addr_t *metric;
  cell_t **row_index;
  ip_addr_t j;
  sort = (ip_addr_t *) malloc (exp (K_SIZE) * sizeof (ip_addr_t));
  if (sort == NULL) {
    printf ("Malloc failure allocating sort vector... can't go on\n");
    return NULL;
  }
  cluster = create_cluster (RLE_seq, &tot_route, sort, &tot_rows[0]);  
  if (cluster == NULL) return NULL;

  metric = (ip_addr_t *) malloc (256 * sizeof (ip_addr_t));
  if (metric == NULL) return NULL;
  for (j = 0; j < 256; j ++) metric[j] = 256;
  /*  Create table */
  row_len[0] = 256;  /*  by costruction  */
  row_index = create_ip_table (cluster, tot_route, sort, metric, 
			       row_len[0], tot_rows[0]);
  if (row_index == NULL) return NULL;
  printf ("table size (rows x cols) %u x %u\n",tot_rows[0], row_len[0]);
  return row_index;
}

/* for each i such that 0 < i < vlen sum(RLE->run_length[i]) = exp_val  */
char createrow (cell_t *row, ip_addr_t *metric, col_index_t size, cluster_t *RLE, col_index_t row_len) {
  ip_addr_t met_i, row_j;
  row_j = 0;
  /*  loop trough metric vector  */
  for (met_i = 0; met_i < size; met_i ++) {
    if (RLE->run_length[row_j] > metric[met_i]) {
      RLE->run_length[row_j] -= metric[met_i];
      row[met_i] = RLE->next_hop[row_j];
    }
    else {
      if (RLE->run_length[row_j] == metric[met_i]) {
	RLE->run_length[row_j] = 0;   /*  useless statement */
	row[met_i] = RLE->next_hop[row_j];
	row_j ++;
      }
      else {
	/* If this happen, congratulation! You found a bug in this software! */
	printf ("\nfail\nMetric error...can't go on\n");
	return -1;
      }
    }
  }
  return 0;
}

cell_t **create_ip_table (cluster_t **cluster, ip_addr_t row_len, ip_addr_t *sort, ip_addr_t *metric, ip_addr_t met_len, ip_addr_t tab_len) {
  ip_addr_t i, j;
  ip_addr_t exp_row = exp (K_SIZE);
  cell_t **tmp, **row_index;
  cell_t *whole;
  printf ("Creating IP table...");
  tmp = (cell_t **) malloc (row_len * sizeof (cell_t *));
  if (tmp == NULL) {
    printf ("fail\nMalloc failure creating support structure...can't go on\n");
    return NULL;
  }
  row_index = (cell_t **) malloc (exp_row * sizeof (cell_t *));
  if (row_index == NULL) {
    printf ("fail\nMalloc failure creating row index...can't go on\n");
    return NULL;
  }
  whole = (cell_t *) malloc (met_len * tab_len * sizeof (cell_t));
  if (whole == NULL) {
    printf ("fail\nMalloc failure creating whole structure...can't go on\n");
    return NULL;
  }
  j = 0;
  
  for (i = 0; i < row_len; i ++) {
    if (cluster[i] != NULL) {
      tmp[i] = whole + (j * met_len * sizeof (cell_t));
      if (createrow (tmp[i], metric, met_len, cluster[i], 0)) return NULL;
      if (tmp[i] == NULL) return NULL;
      free (cluster[i]->run_length);
      free (cluster[i]->next_hop);
      free (cluster[i]);
      j ++;
    }
  }
  /*  Creating row index maintaining data order  */
  for (i = 0; i < exp_row; i ++) {
    row_index[i] = tmp[sort[i]];
  }
  /*  Free temporary structures  */
  free (tmp);
  free (sort);
  free (cluster);
  printf ("done\n");
  return row_index;
}
