#include "iplookup.h"

trie_t *create_mini (struct net_table *in_table) {
  struct net_table *table;  /*  array version  */
  ip_addr_t i;
  trie_t *root;
  printf ("Creating trie...");
  table = in_table;
  /*  Create root for no route to host  */
  if ((root = (trie_t *) malloc (sizeof (trie_t))) == NULL) {
    printf ("fail\n");
    return NULL;
  }
  root->mark = 0;
  root->next_hop = 0; /*  NO ROUTE TO HOST  */
  root->child[0] = NULL;
  root->child[1] = NULL;
  /*  Add networks  */
  for (i = 0; table != NULL; i ++) {
    if (mini_insert (table, root)) {
      printf ("Memory allocation failure...can't go on\nProgram aborted\n");
      return NULL;
    }
    table = table->next;
    /*  Dispose in_table entry  */
    //    free (in_table);
    //in_table = table;
  }
  printf ("done\n");
  return root;
}

int mini_insert (struct net_table *elem, trie_t *root) {
  ip_t i;
  int kid;
  trie_t *node, *tmp;
  node = root;
  for (i = 0; i < elem->netmask; i ++) {
    kid = bit_k (elem->ip, 31 - i);
    if (node->child[kid] == NULL) {   /*  Haven't chlid from kid side  */
      node->child[kid] = malloc (sizeof (trie_t));
      if (!node->child[kid]) return -1;
      tmp = (trie_t *) node->child[kid];
      tmp->next_hop = node->next_hop;
      tmp->child[0] = NULL;
      tmp->child[1] = NULL;
      tmp->mark = 0;
    }
    node = node->child[kid];
  }
  node->next_hop = elem->next_hop;
  node->mark = 1;
  cover_holes (node);
  return 0;
}
