#include "iplookup.h"

#ifdef USE_N_PARTITION
long make_lookups (cell_t **row, addr_table_t **array, ip_addr_t len, 
		   ip_addr_t ntimes, N_part_t *npart, ip_addr_t tot_bas,
		   basic_t *basic) {
#endif
#ifdef USE_K_PARTITION
long make_lookups (cell_t **row, addr_table_t **array, ip_addr_t len, 
		   ip_addr_t ntimes, K_part_t *kpart, basic_t *basic) {
#endif
#ifdef USE_BIN_SEARCH
long make_lookups (cell_t **row, addr_table_t **array, ip_addr_t len, 
		   ip_addr_t ntimes, ip_addr_t tot_bas, basic_t *basic) {
#endif
#ifdef USE_TRIE
long make_lookups (cell_t **row, addr_table_t **array, ip_addr_t len, 
		   ip_addr_t ntimes, trie_t *root) {
#endif
  register ip_addr_t i,j;
#if FINE_TIME
  my_time_t start_time ,stop_time;
  rdtscll (start_time);
#else
  Mark_Time ();
#endif
  /*  repeat the same operation n times  */
  for (i = 0; i < ntimes; i ++) {
    /*  Each loop is a lookup  */
    for (j = 0; j < len; j ++) {
      /*  It's all for this !!!  */
      array[j]->next_hop = row[array[j]->first_pair][array[j]->last_pair >> 8];
      if (array[j]->next_hop == FOLLOW_UP) {
	/*  your own lookup algorithm  */
#ifdef USE_TRIE
    register ip_addr_t query = (array[j]->first_pair << 16) + 
      array[j]->last_pair;
#else
    register ip_addr_t ret, query = (array[j]->first_pair << 16) + 
      array[j]->last_pair;
#endif
#ifdef USE_N_PARTITION
    ret = query_N_partition (npart, query, basic, tot_bas);
#endif
#ifdef USE_K_PARTITION
    ret = query_K_partition (kpart, query, basic);
#endif
#ifdef USE_BIN_SEARCH
    ret = binary_search (basic, tot_bas, query);
#endif
#ifdef USE_TRIE
    array[j]->next_hop = trie_lookup (root, query);
#else
    array[j]->next_hop = basic[ret].rule;
#endif
      }
    }
  }
#if FINE_TIME
  rdtscll (stop_time);
  return stop_time - start_time;
#else
  return Mark_Time ();
#endif
}

