#include "iplookup.h"

ip_addr_t binary_search (basic_t *basic, ip_addr_t len, ip_addr_t query) {
  ip_addr_t low, up, med = ~0, old;
  if (query >= basic[len - 1].endpoint) return len - 1;
  low = 0;
  up = len - 2;
  old = med;
  med = (up + low) / 2;
  while (up != low) {
    if (old == med) med ++;
    if (basic[med].endpoint <= query && query < basic[med + 1].endpoint) 
      return med;
    if (query <= basic[med].endpoint) up = med;
    else low = med;
    old = med;
    med = (up + low) / 2;
  }
  return low;
}


cell_t trie_lookup (trie_t *trie, ip_addr_t lookup) {
  register ip_t i,j;
  register trie_t *root = trie;
  for (i = 33; i != 0; i--, lookup <<= 1) {
    j = (lookup >> 31);
    if (root->child[j] != NULL) root = root->child[j];
    else return root->next_hop;
  }
  return 0;
}


ip_addr_t trie_mem (trie_t *root) {
  /*  if is a leaf  */
  ip_addr_t mem = 0;
  if (root->child[0] == NULL && root->child[1] == NULL) return sizeof (trie_t);
  if (root->child[0] != NULL)
     mem += trie_mem (root->child[0]);
  if (root->child[1] != NULL)
     mem += trie_mem (root->child[1]);
  return mem + sizeof (trie_t);
}
