#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/time.h>
#include <unistd.h>

typedef unsigned char cell_t;     /*  next hop  */
typedef unsigned char ip_t;       /*  IP element from 0 to 255  */
typedef unsigned int ip_addr_t;   /*  IPv4 entire address  */
typedef unsigned short int col_index_t; /*  A type for colunn index  */
typedef unsigned char col_short_t;  /*  Short data value for colun index  */
typedef short int bucket_t;       /*  for bucket colun index  */

typedef unsigned short int usi_t; /*  Short unsigned int  */

#define TRUE 0
#define FALSE 1

#define MAX_IP_LUNG_AS_STRING 16  /*  strlen ("XXX.XXX.XXX.XXX");  */
#define MAX_RIGA_READ 256
#define MAX_NEXT_HOPS 256   /*  Maximum number of next hops in table  */
#define FOLLOW_UP MAX_NEXT_HOPS - 1  /*  match everything */


#define exp(x) (1 << (x))
#define bit_k(x,k) ((x & (1 << (k))) >> (k))
#define Exp(x) (1 << (x))
#define Ph_1(x,k) ((x >> (32 - k)) + 1) << (32 - k)


struct net_table {
  ip_addr_t ip;  
  ip_t netmask;
  cell_t next_hop;
  struct net_table *next;
};
typedef struct {
  char op;
  ip_addr_t ip;  
  ip_t netmask;
  cell_t next_hop;
} update_t;

typedef struct {
  cell_t next_hop;
  ip_t mark; 
  void *child[2];
} trie_t;

/*  loadroute.c  */
int ins_in_next_hop_array (char **next_hops, char *next_hop);
ip_t used_bits (ip_t elem);
ip_t calcola_netmask (ip_t ip1, ip_t ip2, ip_t ip3, ip_t ip4);
ip_addr_t correct_nerwork (ip_addr_t ip, ip_t netmask);
void unload_next_hops (char **next_hops);
struct net_table *load_table (char *nome, char **next_hops,ip_addr_t *rou_c);

/*  cdglookup.c  */
int main (int argc, char *argv[]);

/*  load_addr.c  */
void make_updates (char *nome, char **next_hops, trie_t *root);
 
/*  cdgupdate.c  */
void print_stat (void);
void update (trie_t *root, update_t *request);
void update_announce (trie_t *root, update_t *request);
void update_withdraw (trie_t *root, update_t *request);
ip_addr_t cover_holes_min16 (trie_t *root, ip_t level, 
			     ip_t base, ip_addr_t rows, ip_addr_t *tot);
void cover_holes_16_24 (trie_t *root, ip_t level, ip_t base);
void cover_holes_max24 (trie_t *root, ip_t level, ip_t base);
void get_row_elems (cell_t *riga, trie_t *root, ip_addr_t ip,ip_t mask);
ip_addr_t differ (cell_t *s1, cell_t *s2);


/*  minitrie.c  */
trie_t *create_mini (struct net_table *in_table);
int mini_insert (struct net_table *elem, trie_t *root);
void cover_holes (trie_t *root);

